/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.dashboard.viewlets.web.client.internal.MembersClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");

(function() {

/*
 * Aliases
 */
var TeamServerClient = com.ibm.team.repository.web.transport.TeamServerClient;
var ServiceRequest = com.ibm.team.repository.web.transport.ServiceRequest;

/*
 * Constants
 */
var _SERVICE_URI = "com.ibm.team.dashboard.viewlets.service.internal.members.IMembersService";

com.ibm.team.dashboard.viewlets.web.client.internal.MembersClient.getMembersForTeamArea =
/* ProcessMembersDTO */ function(/* string */ itemId, /* int */ start, /* int */ count, /* string */ token, /* boolean */ details, /* ServiceResponseHandler */ srh, /* ServiceTracker */ tracker) {
	var params = {itemId: itemId, start: start, count: count, token: token};
	if (details) params.details = true;
	var req = new ServiceRequest(_SERVICE_URI, "getMembersForTeamArea", params);
	if (tracker) {
		tracker.register(req, srh);
	}
	TeamServerClient.invokeService(req, srh);
}

com.ibm.team.dashboard.viewlets.web.client.internal.MembersClient.getMembersForProjectArea =
/* ProcessMembersDTO */ function(/* string */ itemId, /* int */ start, /* int */ count, /* string */ token, /* boolean */ details, /* ServiceResponseHandler */ srh, /* ServiceTracker */ tracker) {
	var params = {itemId: itemId, start: start, count: count, token: token};
	if (details) params.details = true;
	var req = new ServiceRequest(_SERVICE_URI, "getMembersForProjectArea", params);
	if (tracker) {
		tracker.register(req, srh);
	}
	TeamServerClient.invokeService(req, srh);
}

})();