/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
    dojo.provide("com.ibm.team.process.web.ui.internal.admin.process_templates.ManageTemplates");//$NON-NLS-1$
    
    dojo.require("dojo.i18n");//$NON-NLS-1$
    dojo.require("dojox.data.dom");//$NON-NLS-1$
    
    dojo.require("net.jazz.ajax.ui.PlatformUI");//$NON-NLS-1$
    
    dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");//$NON-NLS-1$
    
    dojo.require("com.ibm.team.process.web.client.projectarea");//$NON-NLS-1$
    dojo.require("com.ibm.team.repository.web.ui.internal.admin.ItemList");//$NON-NLS-1$
    dojo.require("com.ibm.team.process.web.client.internal.ProcessClient");//$NON-NLS-1$
    dojo.require("com.ibm.team.process.web.ui.internal.admin.process_templates.ImportTemplateDialog");//$NON-NLS-1$
    
    dojo.requireLocalization("com.ibm.team.process.web.ui.internal.admin.process_templates", "Messages");//$NON-NLS-1$//$NON-NLS-2$
    
    var ProcessClient = com.ibm.team.process.web.client.internal.ProcessClient;
    var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
    var ImportTemplateDialog = com.ibm.team.process.web.ui.internal.admin.process_templates.ImportTemplateDialog;
    var SERVICE_URI = dojo.baseUrl + "../../service/com.ibm.team.process.internal.service.web.IProcessDefinitionFileService/";//$NON-NLS-1$
    
    function setText(e, text){
        e.appendChild(document.createTextNode(text));
    }
    
    dojo.declare("com.ibm.team.process.web.ui.internal.admin.process_templates.ManageTemplates", com.ibm.team.repository.web.ui.internal.admin.ItemList, { //$NON-NLS-1$
    
        constructor: function(){
            this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.process_templates", "Messages");//$NON-NLS-1$ //$NON-NLS-2$
        },
        
        postCreate: function(){
            setText(this.heading, this.messages.ManageTemplates_1);
            setText(this.description, this.messages.ManageTemplates_2);
            this.tableHeading.parentNode.removeChild(this.tableHeading);
            this.setHeaderRow([this.messages.ManageTemplates_3, this.messages.ManageTemplates_4]);
            this.headerRow.cells[0].style.width = "30%"; //$NON-NLS-1$
            
            this.importButtonCH = this.addNewButton("", this.messages.ManageTemplates_5); //$NON-NLS-1$
            this.importButton = this.importButtonCH[0];
            
            dojo.disconnect(this.importButtonCH);
            this.connect(this.importButton, "onclick", function(e){ //$NON-NLS-1$            
                var dialog = new ImportTemplateDialog();
                this.connect(dialog, "onSuccess", "performImport");//$NON-NLS-1$ //$NON-NLS-2$ 
            });
            
			this.deployButtonCH = this.addNewButton("", this.messages.ManageTemplates_15);//$NON-NLS-1$
			this.deployButton = this.deployButtonCH[0];
            
            dojo.disconnect(this.deployButtonCH);
            this.connect(this.deployButton, "onclick", "performDeployTemplates");//$NON-NLS-1$ //$NON-NLS-2$
            
            this.deployButton.disabled = true;
		    this.importButton.disabled = true;
		    
            this.refresh();
        },
		
        refresh: function(){
            this.clearState();
            var tr = document.createElement("tr"); //$NON-NLS-1$
            var td = document.createElement("td"); //$NON-NLS-1$
            td.colSpan = 2;
            td.appendChild(document.createTextNode(this.messages.ManageTemplates_6));
            tr.appendChild(td);
            this.tbody.appendChild(tr);
            var srh = new ServiceResponseHandler(this, "showTemplates", "handleShowTemplatesError"); //$NON-NLS-1$ //$NON-NLS-2$ 
            ProcessClient.getPredefinedProcesses(srh);
        },
        
        clearState: function(){
            dojox.data.dom.removeChildren(this.tbody);
            dojox.data.dom.removeChildren(this.messageDiv);
            dojox.data.dom.removeChildren(this.messageBox);
            this.messageBox.className = "";//$NON-NLS-1$
        },
        
        showTemplates: function(data){
            dojox.data.dom.removeChildren(this.tbody);
            var self = this;
            if (data != null) {
                var sortedData = data.sort(function(a, b){
					var translatedNameA = self.getTranslatedProcessDefinitionName(a);
					var translatedNameB = self.getTranslatedProcessDefinitionName(b);
                    return translatedNameA > translatedNameB ? 1 : translatedNameA < translatedNameB ? -1 : 0;
                });
                for (var i = 0; i < sortedData.length; i++) {
                    var row = this.createRowForTemplate(sortedData[i]);
                }
            }
            else {
                this.messageDiv.appendChild(document.createTextNode(this.messages.ManageTemplates_9));  
            }
            this.deployButton.disabled = false;
		    this.importButton.disabled = false;
        },
        
        createRowForTemplate: function(datum){
            var descNode = document.createElement("div"); //$NON-NLS-1$
            //IE does not show top of cell if it has no text, so set the text to
            //a space if the summary is empty.
			var translatedSummary = this.getTranslatedProcessDefinitionSummary(datum); 
            var summaryText = translatedSummary ?  translatedSummary : " "; //$NON-NLS-1$
            descNode.appendChild(document.createTextNode(summaryText));
            
            var row = this.addRow(null, [this.getTranslatedProcessDefinitionName(datum), descNode]);
            
            var exportIcon = this.createImage("ui/internal/images/export.gif", "ui/internal/images/export_hov.gif", this.messages.ManageTemplates_7, datum.itemId);//$NON-NLS-1$//$NON-NLS-2$
            var href = SERVICE_URI + datum.itemId;
            var hyperlink = document.createElement("a");//$NON-NLS-1$
            hyperlink.setAttribute("href", href); //$NON-NLS-1$            
            hyperlink.appendChild(exportIcon);
            row.cells[0].insertBefore(hyperlink, row.cells[0].firstChild);
            
            var deleteIcon = this.createImage("ui/internal/images/delete.gif", "ui/internal/images/delete_hov.gif", this.messages.ManageTemplates_17, datum.itemId);//$NON-NLS-1$//$NON-NLS-2$
            this.connect(deleteIcon, "onclick", function(e){//$NON-NLS-1$
                this.handleDeleteTemplate(e);
            });
            var hyperlink = document.createElement("a");//$NON-NLS-1$
            hyperlink.setAttribute("href", "#"); //$NON-NLS-1$ //$NON-NLS-2$            
            hyperlink.appendChild(deleteIcon);
            row.cells[0].insertBefore(hyperlink, row.cells[0].firstChild);
            
            dojo.toggleClass(row.parentNode, "projectTable", true);//$NON-NLS-1$
            return row;
        },
		/**
		 * Create an image that will change when the user 
		 * "hovers" over it with the mouse.
		 * @param {Object} imagePath path relative to the process web bundle of 
		 * the image that is shown when the user is not hovering. 
		 * @param {Object} hoverImagePath path relative to the process web 
		 * bundle of the image that is shown when the user is hovering.
		 * @param {Object} tooltip string that appears when the user hovers
		 * @param {Object} processItemId the id process template associated with
		 * this hyperlink.
		 */
		createImage: function(imagePath, hoverImagePath, tooltip, processItemId) {
			var exportIcon = document.createElement("img"); //$NON-NLS-1$
            exportIcon.src = dojo.moduleUrl("com.ibm.team.process.web", imagePath);//$NON-NLS-1$ //$NON-NLS-2$
            exportIcon.title = tooltip;
            exportIcon.className = "archiveIcon";//$NON-NLS-1$
			exportIcon.projectItemId = processItemId;
            this.connect(exportIcon, "onmouseover", function(e){ //$NON-NLS-1$
                e.target.src = dojo.moduleUrl("com.ibm.team.process.web", hoverImagePath);//$NON-NLS-1$ //$NON-NLS-2$
            });
            this.connect(exportIcon, "onmouseout", function(e){//$NON-NLS-1$
                e.target.src = dojo.moduleUrl("com.ibm.team.process.web", imagePath);//$NON-NLS-1$ //$NON-NLS-2$ 
            });
			return exportIcon;
		},
		
		handleDeleteTemplate: function(e) {
			dojo.stopEvent(e);
			var processItemId = e.target.projectItemId;
			if (confirm(this.messages.ImportTemplateDialog_9)) {
				this.displayPendingMessage(this.messages.ImportTemplateDialog_10);
				var srh = new ServiceResponseHandler(this, "handleDeleteTemplateSuccess", "handleDeleteTemplateError"); //$NON-NLS-1$ //$NON-NLS-2$
				ProcessClient.deleteProcessDefinition({
					uuid: processItemId
				}, srh);
			}
		},
		
        handleDeleteTemplateSuccess: function(processDefinitionDTO){          
            //remove the row from the table
            var theFilter = "a[href*='" + processDefinitionDTO.itemId + "']"; //$NON-NLS-1$ //$NON-NLS-2$
            var anchors = dojo.query(theFilter, document);
            if (anchors.length > 0) {
                var theAnchor = anchors[0];
                var row = theAnchor.parentNode.parentNode;
                row.parentNode.removeChild(row);
            }
			this.clearMessage();
        }, 
		
		handleDeleteTemplateError : function(error) {
			var msg = document.createElement("div");//$NON-NLS-1$
            msg.appendChild(document.createTextNode(this.messages.ManageTemplates_16));
            if (error.message) {
                msg.appendChild(document.createElement("br"));//$NON-NLS-1$
                msg.appendChild(document.createElement("br")); //$NON-NLS-1$
                msg.appendChild(document.createTextNode(error.message));
            }
            this.displayErrorMessage(msg, true);
		},
		
		/**
		 * Deploy templates and update the table.
		 */
        performDeployTemplates: function(e){
            dojo.stopEvent(e);
            this.deployButton.disabled = true;
            this.importButton.disabled = true;
			dojox.data.dom.removeChildren(this.tbody);
            dojox.data.dom.removeChildren(this.messageDiv);
            this.messageDiv.appendChild(document.createTextNode(this.messages.ManageTemplates_13));
            var srh = new ServiceResponseHandler(this, "handleDeployTemplateSuccess", "handleDeployTemplateError"); //$NON-NLS-1$ //$NON-NLS-2$
            ProcessClient.deployPredefinedProcessDefinitions(srh);            
        },
		
		handleDeployTemplateSuccess : function() {
			this.refresh();
		},
		
		handleShowTemplatesError: function(error) {
			var title = this.messages.ManageTemplates_18;
			this.handleTemplateError(title, error.message);
		},
		
        handleDeployTemplateError: function(error){		
			var title = this.messages.ManageTemplates_14;
			this.handleTemplateError(title, error.message);
        },
        
        handleTemplateError: function(errorTitle, errorMessage) {
        	dojox.data.dom.removeChildren(this.tbody);
        	//show the error
            var msg = document.createElement("div");//$NON-NLS-1$
            msg.appendChild(document.createTextNode(errorTitle));
            if (errorMessage) {
                msg.appendChild(document.createElement("br"));//$NON-NLS-1$
                msg.appendChild(document.createElement("br")); //$NON-NLS-1$
                msg.appendChild(document.createTextNode(errorMessage));
            }
            this.displayErrorMessage(msg, true);
            this.deployButton.disabled = false;
            this.importButton.disabled = false;
        }, 
        
        /**
         * update the table with the new (or overwritten) template
         * @param {Object} processId the id of the process that was created or
         * overwritten.
         */
        performImport: function(processId, isNew){
            var srh;
            if (isNew) {
                srh = new ServiceResponseHandler(this, "handleNewProcess", "handleNewProcessError");//$NON-NLS-1$ //$NON-NLS-2$
            }
            else {
                srh = new ServiceResponseHandler(this, "handleOverwrittenProcess", "handleNewProcessError");//$NON-NLS-1$ //$NON-NLS-2$ 
            }
            ProcessClient.getProcessDefinitionById({
                definitionId: processId
            }, srh);
        },
		
        handleNewProcess: function(data){
            this.createRowForTemplate(data);
        },
		
        handleNewProcessError: function(data){
            if (data instanceof Error) {
                this.displayErrorMessage(data.message);
            }
        },
		
        getTranslatedProcessDefinitionName: function(definition){
            var translatedName;
            
            if (definition.supportedLocales && definition.supportedLocales.length > 0) {
                // try the client locale next
                var locale = djConfig.locale;
                if (locale) { 
                	var localeIndex = dojo.indexOf(definition.supportedLocales, locale);
                	if (localeIndex != -1) {
                    	translatedName = definition.translatedNames[localeIndex];
                    }
                }
                
                if (!translatedName) {
                    // try any supported locales with the same language code
                    if (locale && locale.length > 2) {
                        var clientLocaleLang = locale.substring(0, 2);
                        
                        for (var i = 0; i < definition.supportedLocales.length; i++) {
                            if (definition.supportedLocales[i].indexOf(clientLocaleLang) == 0) {
                            	translatedName = definition.translatedNames[i];
                                if (translatedName && translatedName.length != 0) {
                                    break;
                                }
                            }
                        }
                    }
                }
            }
            
            // next try the default locale for the process definition
            if (!translatedName) {
                translatedName = definition.defaultName;
            }
            
            // finally default to the untranslated value
            if (!translatedName) {
                translatedName = definition.name;
            }
            
            return translatedName;
        },
		
		getTranslatedProcessDefinitionSummary: function(definition){
            var translatedSummary;
            
            if (definition.supportedLocales && definition.supportedLocales.length > 0) {
                // try the client locale next
                var locale = djConfig.locale;
                if (locale) {
                	var localeIndex = dojo.indexOf(definition.supportedLocales, locale);
                	if (localeIndex != -1) {
                    	translatedSummary = definition.translatedSummaries[localeIndex];
                    }
                }
                
                if (!translatedSummary) {
                    // try any supported locales with the same language code
                    if (locale && locale.length > 2) {
                        var clientLocaleLang = locale.substring(0, 2);
                        
                        for (var i = 0; i < definition.supportedLocales.length; i++) {
                            if (definition.supportedLocales[i].indexOf(clientLocaleLang) == 0) {
                                translatedSummary = definition.translatedSummaries[i];
                                if (translatedSummary && translatedSummary.length != 0) {
                                    break;
                                }
                            }
                        }
                    }
                }
            }
            
            // next try the default locale for the process definition
            if (!translatedSummary) {
                translatedSummary = definition.defaultSummary;
            }
            
            // finally default to the untranslated value
            if (!translatedSummary) {
                translatedSummary = definition.summary;
            }
            
            return translatedSummary;
        },
        /**
         * update the row for the given process template
         * @param data is a ProcessDefinitionDTO
         */
        handleOverwrittenProcess: function(processDefinitionDto){
            var newProcessId = processDefinitionDto.itemId;
            var allRows = dojo.query("tr");//$NON-NLS-1$
            
            allRows.forEach(function f(x){
                var theFilter = "a[href*='" + newProcessId + "']"; //$NON-NLS-1$ //$NON-NLS-2$
                var anchors = dojo.query(theFilter, x);
                if (anchors.length > 0) {
                    //we found the row with the item --update it
                    var theAnchor = anchors[0];
                    var row = theAnchor.parentNode.parentNode;
                    var nameCell = row.cells[0];
                    var translatedName = this.getTranslatedProcessDefinitionName(processDefinitionDto);
                    if(dojo.isIE) {
                    	var cellNode = nameCell.childNodes[1];
                    	cellNode.nodeValue = translatedName;
                    } else {
						nameCell.childNodes[2].textContent = translatedName;
					}
					
                    var summaryCell = row.cells[1];
					var summary = this.getTranslatedProcessDefinitionSummary(processDefinitionDto); 
                    if (summary) {
                        summaryCell.innerHTML = "<div>" + summary + "</div>"; //$NON-NLS-1$ //$NON-NLS-2$ 
                    }
                }
                
            }, this);
        }
    });
    
})();
