/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.GroupModeOwner"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.BarModes"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.AbstractGroupMode"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.Columns"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.common.WorkLoadInformation"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.require("dojo.i18n"); //$NON-NLS-1$

(function() {

var bind= dojo.string.substitute;
var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$
	
var BarModes			= com.ibm.team.apt.web.ui.internal.view.plan.planneditems.BarModes;
var Columns				= com.ibm.team.apt.web.ui.internal.view.plan.planneditems.Columns;
var ITEM_TYPES			= com.ibm.team.apt.web.ui.internal.common.ReferencedItemStore.ITEM_TYPES;

var WorkLoadInformation	= com.ibm.team.apt.web.ui.internal.common.WorkLoadInformation;

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.GroupModeOwner",  //$NON-NLS-1$
			  com.ibm.team.apt.web.ui.internal.view.plan.planneditems.AbstractGroupMode, {

	_columns: [Columns["summary"], Columns["estimate"], Columns["priority"], Columns["id"]], //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ 

	// ---- api ------------------------------------------------------------------------------------------------------------

	// ---- AbstractGroupMode.js implementation ----------------------------------------------------------------------------
	
	getGroupModeId: function() {
		return "owner"; //$NON-NLS-1$
	},

	getGroupModeLabel: function() {
		return MSGS.GROUPMODE_OWNER;
	},

	getColumns: function() {
		return this._columns;
	},

	getGroupSorter: function() {
		return dojo.hitch(this, this._groupSortFn);
	},

	getBarModes: function() {
		return [BarModes.progress, BarModes.load];
	},

	getGroupId: function(workItemStack) {
		var workItem= workItemStack[workItemStack.length - 1];
		return workItem.auxiliary ? null : workItem.owner;
	},

	getGroupDescription: function(groupId) {
		var contributor= this._getReferencedItem(ITEM_TYPES.CONTRIBUTOR, groupId);

		var result= {
			name: contributor.label,
			photo: contributor.photoURL
		};

		var workLoad= this._plannedItemsPage.getWorkLoad(groupId);
		if (workLoad != null) {
			result["workLoad"]= new WorkLoadInformation(workLoad); //$NON-NLS-1$
		}
		
		return result;
	},

	getDefaultGroupIds: function() {
		return this._plannedItemsPage.getTeamMembers();
	},

	geWorkItemWidgetOptions: function(workItem) {
		var result= null;
		if (workItem.isTopLevelPlanItem()) {
			result= {
				overrideColumn: {
					column: Columns["estimate"], //$NON-NLS-1$
					replacement: Columns["empty"], //$NON-NLS-1$
					columnSpan: 1
				}
			}
		}
		return result;
	},
	
	_calculateProgress: function(treeNode) {
		var result= this.inherited(arguments);
		
		var workLoad= this._plannedItemsPage.getWorkLoad(treeNode.getNodeId());
		if (workLoad != null) {
			result.setRealTimeDone(workLoad.realTimeDone);
			result.setRealTimeLeft(workLoad.realTimeLeft);
		}

		return result;
	},

	// ---- implementation -------------------------------------------------------------------------------------------------

	_groupSortFn: function(groupNodeA, groupNodeB) {
		var categoryA= this._groupCategory(groupNodeA);
		var categoryB= this._groupCategory(groupNodeB);
		
		if (categoryA != categoryB)
			return categoryA - categoryB;
			
		var labelA= groupNodeA.getNodeValue().name;
		var labelB= groupNodeB.getNodeValue().name;
		
		if (labelA == labelB)
			return 0;
		return labelA < labelB ? -1 : 1;
	},
	
	_groupCategory: function(groupNode) {
		if (this._plannedItemsPage.getWorkLoad(groupNode.getNodeId()) != null)
			// this is a team member
			return 1;

		return groupNode.getNodeValue().itemId != "_YNh4MOlsEdq4xpiOKg5hvA" ? 2 : 3; //$NON-NLS-1$
	},


	__sentinel: null // terminates this class definition
});


})();
