/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2008. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.queryeditor.UserSection");

dojo.require("com.ibm.team.process.web.ui.internal.TeamContributorSelectionDialog");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.queryeditor.EditableTableSection");
dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "QueryMessages");

(function() {
	
var EditableTableSection= com.ibm.team.workitem.web.ui.internal.view.queryeditor.EditableTableSection;
var TableEntry= com.ibm.team.workitem.web.ui.internal.view.queryeditor.TableEntry;
var SelectContributorDialog = com.ibm.team.process.web.ui.internal.TeamContributorSelectionDialog;

dojo.declare("com.ibm.team.workitem.web.ui.internal.view.queryeditor.UserSection", EditableTableSection, {
	constructor: function() {
		this.messages = dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "QueryMessages");
	},
	onAdd: function(event) {
		event.preventDefault();
		
		var self= this;
		var params= {
				title: this.messages.dialogTitleAddUsers,
				parentElement: this.domNode,
				disableUsers: [],
				onOK: function(selectedContribs) {
					self._addUsers(selectedContribs);
				}
			};
		new SelectContributorDialog(params);

	},
	
	setInput: function(users) {
		this.deleteAllEntries();
		if (users)
			this._addItems(users);
		this._setChanged(false);
	},
	
	_addItems: function(items) {
		for (var i= 0; i < items.length; i++) {
			this._addItem(items[i]);
		}
	},
	
	_addItem: function(item) {
		var entry= new TableEntry({ item: item, labelProperty: "label", section: this });
		this.addEntry(entry);
	},
	
	_addUsers: function(users) {
		for (var i= 0; i < users.length; i++) {
			var user= users[i];
			var item= { label: user.name, id: user.itemId };
			this._addItem(item);
		}
	}
});
	
})();
